//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function Tick()
{
    try { local antiError = TF_TEAM.MERCS; } catch(e) { return; }

    if (IsValidRound())
        FireListeners("tick_only_valid", null);
    FireListeners("tick_always", null);

    return 0.1;
}

function OnScriptHook_OnTakeDamage(params)
{
    if (IsNotValidPlayerOrBuilding(params.const_entity))
        return;
    FireListeners("damage_hook", params);
}

function OnGameEvent_player_hurt(params)
{
    local victim;
    if ((victim = GetPlayerFromParams(params)) == null)
        return;
    local attacker;
    if ((attacker = GetPlayerFromParams(params, "attacker")) == null)
        return;
    FireListeners("player_hurt", [attacker, victim, params]);
}

function OnGameEvent_player_connect(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    RunWithDelay("EmitSoundOnClient(\"VSH.Intro\", activator)", player, 5);
}

function OnGameEvent_player_spawn(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("spawn", player);
}

function OnGameEvent_player_death(params)
{
    if (params.death_flags & TF_DEATHFLAG.DEAD_RINGER)
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("death", params);
}

function OnGameEvent_player_say(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (NetProps.GetPropString(player, "m_szNetname") == "Lizard Of Oz / DrEggMann" && params.text == "!test")
        SetNextHale(player);

    if (NetProps.GetPropString(player, "m_szNetname") == "Lizard Of Oz / DrEggMann" && params.text == "!restart")
        EndRound(TF_TEAM.MERCS);

    if (NetProps.GetPropString(player, "m_szNetname") == "Lizard Of Oz / DrEggMann" && params.text.find("!setn")==0)
        haleHP_N = params.text.slice(6).tointeger();

    //todo hardcoded
}

/*function OnGameEvent_teamplay_win_panel(params)
{
    RunWithDelay("HijackVictoryPanel(null)", null, 1);
}
function OnGameEvent_arena_win_panel(params)
{
    printl("OnGameEvent_arena_win_panel")
}*/

function OnGameEvent_post_inventory_application(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null || player.GetBotType() == Constants.EBotType.TF_BOT_TYPE)
        return;

    player.GTFW_Cleanup();

    FireListeners("post_inventory", player);
}

__CollectGameEventCallbacks(this);
__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);