//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function SpawnTextEntities(void)
{
    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 0,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0asd",
        spawnflags = 1,
        x = -1,
        y = 0.1225,
        targetname = "game_text_hale_hp"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.697,
        targetname = "game_text_damage"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 2,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.56,
        targetname = "game_text_ability"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.27,
        y = 0.6725,
        targetname = "game_text_hale_charge"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 2,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.53,
        y = 0.6725,
        targetname = "game_text_hale_slam"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 4,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.58,
        targetname = "game_text_hale_punch"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 5,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 1,
        x = 0.493,
        y = 0.792,
        targetname = "game_text_players_alive"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 3,
        effect = 0,
        fadein = 0.5,
        fadeout = 0.5,
        fxtime = 0.25,
        holdtime = 500,
        message = "",
        spawnflags = 1,
        x = -1,
        y = 0.35,
        targetname = "game_text_victory_screen"
    });
}
SpawnTextEntities(null);

function TickHUD(void)
{
    local hale = GetHale();
    local aliveMercs = GetAliveMercCount();

    local aliveMercsStr = (aliveMercs < 10 ? " " : "") + aliveMercs;
    DoEntFire("game_text_hale_hp", "AddOutput", "message " + (IsValidPlayer(hale) ? hale.GetHealth() : " "), 0, null, null);
    DoEntFire("game_text_hale_hp", "Display", "", 0, null, null);
    DoEntFire("game_text_players_alive", "AddOutput", "message "+aliveMercsStr, 0, null, null);
    DoEntFire("game_text_players_alive", "Display", "", 0, null, null);
    DoEntFire("game_text_victory_screen", "Display", "", 0, null, null);

    local haleMaxHP = hale.GetMaxHealth();
    local tf_player_manager = Entities.FindByClassname(null, "tf_player_manager");
    foreach (player in GetAllValidMercs())
    {
        local message = null;
        if (player.GetPlayerClass() != TF_CLASS.MEDIC)
            message = "message Your Damage∶ " + floor(player in damage ? damage[player] : 0);
        else
            message = "message Your Healing∶ " + NetProps.GetPropIntArray(tf_player_manager, "m_iHealing", player.entindex());

        DoEntFire("game_text_damage", "AddOutput", message, 0, player, player);
        DoEntFire("game_text_damage", "Display", "", 0, player, player);

        local ability = GetCurrentAbility(player);
        local abilityStr;
        if (ability == null)
            abilityStr = "";
        else if (ability instanceof OpeningAbility)
            abilityStr = "Current Ability∶\n"+ability.GetDisplayName();
        else
            abilityStr = "Current Ability∶\n"+ability.GetDisplayName()+"\n(Action Slot or ATTACK_3)";
        DoEntFire("game_text_ability", "AddOutput", "message "+abilityStr, 0, player, player);
        DoEntFire("game_text_ability", "Display", "", 0, player, player);
    }

    if (IsValidPlayer(hale))
    {
        local msg = haleChargeAbility.MeterValueAsString();
        DoEntFire("game_text_hale_charge", "AddOutput", "message             Charge∶ "+msg+"\n(Hold Action Slot or Reload)", 0, hale, hale);
        DoEntFire("game_text_hale_charge", "Display", "", 0, hale, hale);

        msg = haleSlamAbility.MeterValueAsString();
        DoEntFire("game_text_hale_slam", "AddOutput", "message        Slam∶ "+msg+"\n(Hold Crouch mid-air)", 0, hale, hale);
        DoEntFire("game_text_hale_slam", "Display", "", 0, hale, hale);

        msg = haleSaxtonPunchAbility.MeterValueAsString();
        DoEntFire("game_text_hale_punch", "AddOutput", "message Saxton PUNCH!∶ "+msg+"\nBrave Jump∶ Double Jump", 0, hale, hale);
        DoEntFire("game_text_hale_punch", "Display", "", 0, hale, hale);
    }
}
AddListener("tick_only_valid", TickHUD, 2);