//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

haleStartHealth <- 9001;
damage <- {}
starterClass <- {}

function ResetRoundDamage()
{
    damage <- {};
}

function GetRoundDamage(player)
{
    return player in damage ? damage[player] : 0;
}

function SetRoundDamage(player, damageValue)
{
    damage[player] <- damageValue;
}

function RecordRoundDamage(args)
{
    local attacker = args[0];
    local victim = args[1];
    local damage = args[2].damageamount;
    if (IsNotHale(victim))
        return;
    SetRoundDamage(attacker, GetRoundDamage(attacker) + damage);
}
AddListener("player_hurt", RecordRoundDamage, 1);

function GetDamageBoardSorted()
{
    function sortFunction(it, that)
    {
        return that[1] - it[1];
    }

    local damageAsArray = []
    foreach(player, dmg in damage)
        damageAsArray.push([player, dmg]);
    damageAsArray.sort(@(it, that) that[1] - it[1]);
    return damageAsArray;
}