//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

haleStunBreakoutAbility <- null;
haleSlamAbility <- null;
haleChargeAbility <- null;
haleSaxtonPunchAbility <- null;
haleBraveJumpAbility <- null;
haleAbilities <- [];

class HaleAbility
{
    meter = 0;

    function Tick(hale, interval) { }
    function FrameTick(hale) { }
    function IsReady(hale) { return false; }
    function Perform(hale) { }
    function MeterValueAsString() { return null; }
}

IncludeScript("vssaxtonhale/hale/hale_abilities/brave_jump.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/charge.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/mighty_slam.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/saxton_punch.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities/stun_breakout.nut");

function TickHaleAbilities(void)
{
    local hale = GetHale();
    if (IsNotHale(hale))
        return;

    foreach (ability in haleAbilities)
        ability.Tick(hale, 0.1);
}
AddListener("tick_only_valid", TickHaleAbilities, 0);

function FrameTickHaleAbilities(void)
{
    local hale = GetHale();
    if (IsNotHale(hale))
        return;

    foreach (ability in haleAbilities)
        ability.FrameTick(hale);
}
AddListener("tick_frame", FrameTickHaleAbilities, 0);

function CreateAoE(center, radius, applyDamageFunc, applyPushFunc)
{
    foreach(target in GetAliveMercs())
    {
        local deltaVector = target.GetCenter() - center;
        local distance = deltaVector.Norm();
        if (distance > radius)
            continue;

        applyPushFunc(target, deltaVector, distance);
        applyDamageFunc(target, deltaVector, distance);
    }

    local target = null;
    while (target = Entities.FindByClassname(target, "obj_*"))
    {
        local deltaVector = target.GetCenter() - center;
        local distance = deltaVector.Norm();
        if (distance > radius)
            continue;

        applyDamageFunc(target, deltaVector, distance);
    }
}

function ResetAbilities()
{
    haleStunBreakoutAbility = StunBreakOutHaleAbility();
    haleSlamAbility = SlamHaleAbility();
    haleChargeAbility = ChargeHaleAbility();
    haleSaxtonPunchAbility = SaxtonPunchHaleAbility();
    haleBraveJumpAbility = BraveJumpHaleAbility();
    haleAbilities = [haleStunBreakoutAbility, haleSlamAbility, haleChargeAbility, haleSaxtonPunchAbility, haleBraveJumpAbility];
}