//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class SaxtonPunchHaleAbility extends HaleAbility
{
    meter = -30;
    function IsReady(hale)
    {
        return meter == 0;
    }

    function MeterValueAsString()
    {
        if (meter == 0)
            return "Ready";
        else if (meter < 0)
            return format("%.1fs", -meter);
        else
            return format("%d%%", meter * 100);
    }

    function Tick(hale, interval)
    {
        if (meter < 0 && !vsh_vscript.IsRoundSetup())
        {
            meter += interval;
            if (meter >= 0)
            {
                meter = 0;
                EmitSoundOn("VSH.PunchReadyVO", hale);
                EmitSoundOnClient("VSH.PunchReadySFX", hale);
                hale.AddCond(Constants.ETFCond.TF_COND_CRITBOOSTED);
            }
        }
    }

    function Perform(hale, victim)
    {
        if (!IsReady(hale))
            return;
        meter -= 30;

        local haleEyeVector = hale.EyeAngles().Forward();
        haleEyeVector.Norm();

        hale.RemoveCond(Constants.ETFCond.TF_COND_CRITBOOSTED);
        EmitSoundOn("TFPlayer.CritHit", hale);
        EmitSoundOn("VSH.PunchSFX", hale);
        if (RandomInt(1,3))
            EmitSoundOn("VSH.Punch", hale);
        DispatchParticleEffect("passtime_air_blast", victim.GetCenter(), haleEyeVector);
        DispatchParticleEffect("Explosion_ShockWave_01", victim.GetOrigin(), Vector(0,0,0));
        ScreenShake(hale.GetCenter(), 10, 2.5, 1, 1000, 0, true);

        vsh_vscript.CreateAoE(hale.GetCenter(), 600,
            function (target, deltaVector, distance) {
                local dot = haleEyeVector.Dot(deltaVector);
                if (dot < 0.6)
                    return;
                DispatchParticleEffect("mvm_pow_punch", target.EyePosition() + Vector(0,0,30), Vector(0,0,0));
                target.TakeDamageEx(
                    hale,
                    hale,
                    hale.GetActiveWeapon(),
                    deltaVector,
                    hale.GetOrigin(),
                    target.GetMaxHealth() * (0.6 - distance / 1000),
                    1);
            }
            function (target, deltaVector, distance) {
                local dot = haleEyeVector.Dot(deltaVector);
                if (dot < 0.6)
                    return;
                local pushForce = distance < 100 ? 10 : 10 / sqrt(distance);
                deltaVector.x = deltaVector.x * 1250 * pushForce;
                deltaVector.y = deltaVector.y * 1250 * pushForce;
                deltaVector.z = 750 * pushForce;
                target.Yeet(deltaVector);
            });
    }
}