//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::haleConversionAttempts <- 0

function TrySpawnAsHale(hale)
{
    if (IsNotValidPlayer(hale) || IsNotHale(hale) || haleConversionAttempts > 10)
        return;
    ResetAbilities();
    //printl("\n>>>   TrySpawnAsHale "+hale)
    /*printl("PlayersAreOnMatchSummaryStage="+PlayersAreOnMatchSummaryStage())
    printl("haleConversionAttempts="+haleConversionAttempts)
    printl("UsePlayerReadyStatusMode="+UsePlayerReadyStatusMode()+"\n")*/

    haleConversionAttempts++;
    hale.KeyValueFromString("targetname", "hale");

    local spotlight = Entities.FindByName(null, "spotlight");
    if (spotlight != null)
    {
        local pos = hale.GetCenter();
        spotlight.SetAbsOrigin(pos);
        DoEntFire("spotlight", "SetParent", "!activator", 0.1, hale, hale)
    }

    if (hale.GetTeam() != TF_TEAM.HALE)
    {
        hale.ForceChangeTeam(TF_TEAM.HALE, true);
        hale.ForceRespawn();
    }
    NetProps.SetPropInt(hale, "m_PlayerClass.m_iClass", TF_CLASS.HEAVY);

    hale.SetCustomModelWithClassAnimations(SAXTON_HALE_MODEL_PATH);

    local wearable = null;
    while (wearable = Entities.FindByClassname(wearable, "tf_wearable*"))
    {
        if (wearable.GetOwner() == hale)
            wearable.Destroy();
    }
    local weapon = null;
    while (weapon = Entities.FindByClassname(weapon, "tf_weapon*"))
    {
        if (weapon.GetOwner() == hale)
            weapon.Destroy();
    }
    local bottle = null;
    while (bottle = Entities.FindByClassname(bottle, "tf_powerup_bottle"))
    {
        if (bottle.GetOwner() == hale)
            bottle.Destroy();
    }

    NetProps.SetPropEntity(hale, "m_hActiveWeapon", hale.GiveWeapon("Hale's Own Fists"));

    local banner = AddWeapon(hale, "tf_weapon_minigun", 444, "", 1); //Buff Banner in name, Manthreads in ID
    banner.KeyValueFromString("classname", "dummy");

    //Stats
    hale.SetModelScale(1.2, 0);

    TickSetupHealth(hale);

    hale.AddCustomAttribute("move speed bonus", 1.8, -1);
    hale.AddCustomAttribute("cancel falling damage", 1, -1);
    hale.AddCustomAttribute("voice pitch scale", 0, -1);
    hale.AddCustomAttribute("melee range multiplier", 1.2, -1);
    hale.AddCustomAttribute("damage bonus", 3, -1);
    hale.AddCustomAttribute("melee bounds multiplier", 1.1, -1);
    hale.AddCustomAttribute("no crit boost", 1, -1);
    hale.AddCustomAttribute("crit mod disabled hidden", 0, -1);
    hale.AddCustomAttribute("increase player capture value", 2, -1);
    //hale.AddCustomAttribute("increased air control", 2.5, -1);
    hale.AddCustomAttribute("cannot pick up intelligence", 1, -1);
    hale.AddCustomAttribute("patient overheal penalty", 1, -1);
    hale.AddCustomAttribute("health from packs decreased", 0, -1);
    //hale.AddCustomAttribute("damage force reduction", 0.75, -1);
    //hale.AddCustomAttribute("dmg bonus vs buildings", 10, -1);
    //hale.AddCustomAttribute("SET BONUS: dmg from sentry reduced", 0.5, -1);
    hale.AddCustomAttribute("dmg taken from crit reduced", 0.75, -1);

    hale.AddCond(Constants.ETFCond.TF_COND_CANNOT_SWITCH_FROM_MELEE);
}
AddListener("spawn", TrySpawnAsHale, 0);
AddListener("post_inventory", TrySpawnAsHale, 0);