//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function HaleTookDamageEvent(params)
{
    local hale = params.const_entity;
    local attacker = params.attacker;
    local inflictor = params.inflictor;
    local weapon = params.weapon;

    if (IsNotHale(hale) || !IsValidPlayer(attacker))
        return;

    if (IsRoundSetup())
    {
        params.damage = 0;
        params.early_out = true;
        return;
    }

    //Le backstabe
    if (params.damage_custom == Constants.ETFDmgCustom.TF_DMG_CUSTOM_BACKSTAB)
    {
        params.damage = CalcStabDamage() / 2.5; //Crit compensation

        NetProps.SetPropFloat(weapon, "m_flNextPrimaryAttack", Time() + 2.0);
        NetProps.SetPropFloat(attacker, "m_flNextAttack", Time() + 2.0);
        NetProps.SetPropFloat(attacker, "m_flStealthNextChangeTime", Time() + 2.0);
        EmitSoundOn("Player.Spy_Shield_Break", hale);
        EmitSoundOn("Player.Spy_Shield_Break", hale);
    }
    //Headshot (compensating for Hale's crit res)
    if (params.damage_custom == Constants.ETFDmgCustom.TF_DMG_CUSTOM_HEADSHOT)
        params.damage *= 1.25;

    //Miniguns (nerf damage and knockback by 40%)
    if (weapon != null && weapon.GetClassname() == "tf_weapon_minigun")
        params.damage *= 0.6;

    //Sentry (nerf damage and knockback by 50%)
    if (inflictor != null && inflictor.GetClassname() == "obj_sentrygun")
    {
        params.damage *= 0.5;
    }

    //Holiday Punch (tracking the taunt stun)
    if (GetItemID(params.weapon) == 656)
        haleStunBreakoutAbility.haleLastTimeHolidayPunch = Time();
}
AddListener("damage_hook", HaleTookDamageEvent, 1);