::mercChangesClasses <- [];
::mercChanges <- {};

IncludeScript("vssaxtonhale/mercs/merc_changes/merc_change_base.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/melee_wall_climb.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/melee_crits.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/market_garden_damage_boost.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/demo_shield_protection.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/last_mann_standing.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/ubercharge_rate_bonus.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/on_kill/generic_on_kill_to_on_hit.nut");

function ApplyMercChanges(player)
{
    foreach (player in GetAliveMercs())
    {
        mercChanges[player] <- [];

        foreach (mercChange in mercChangesClasses)
            mercChange(player);
    }
}
AddListener("spawn", ApplyMercChanges, -1);

function TickMercChanges(void)
{
    foreach (player in GetAliveMercs())
        if (player in mercChanges)
            foreach (mercChange in mercChanges[player])
                mercChange.OnTickInner();
}
AddListener("tick_always", TickMercChanges, 2);

function MercDamageEvent(params)
{
    local victim = params.const_entity;
    local attacker = params.attacker;

    if (IsHale(victim) && IsValidPlayer(attacker))
        foreach (mercChange in mercChanges[attacker])
            mercChange.OnDamageDealt(params);

    else if (IsHale(attacker) && IsValidPlayer(victim))
        foreach (mercChange in mercChanges[victim])
            mercChange.OnDamageTaken(params);
}
AddListener("damage_hook", MercDamageEvent, 0);