//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::IsMercAlive <- function(player)
{
    return IsValidPlayer(player) && IsNotHale(player) && IsPlayerAlive(player);
}

function TrySpawnAsMerc(player)
{
    if (!IsMercAlive(player))
        return;

    printl("TrySpawnAsMerc for "+player);

    player.SetCustomModelWithClassAnimations("")
    GrantAbilityToPlayer(player, null);
    player.SetGravity(1);

    if (player.GetTeam() != TF_TEAM.MERCS)
    {
        player.ForceChangeTeam(TF_TEAM.MERCS, true);
        player.ForceRegenerateAndRespawn();
    }

    if (player.GetPlayerClass() == TF_CLASS.SNIPER && GetItemID(player.ReturnWeaponBySlot(1)) == 58)
    {
        player.DeleteWeapon("Jarate");
        player.GiveWeapon("SMG");
        ClientPrint(player, 3, "Jarate is TEMPORARILY disabled.");
    }
    if (player.GetPlayerClass() == TF_CLASS.SNIPER && GetItemID(player.ReturnWeaponBySlot(0)) == 230)
    {
        player.DeleteWeapon("Sydney Sleeper");
        player.GiveWeapon("Sniper Rifle");
        ClientPrint(player, 3, "Sydney Sleeper is TEMPORARILY disabled.");
    }
    if (player.GetPlayerClass() == TF_CLASS.HEAVY && GetItemID(player.ReturnWeaponBySlot(0)) == 41)
    {
        player.GiveWeapon("Minigun");
        ClientPrint(player, 3, "Natasha is TEMPORARILY disabled.");
    }
}
AddListener("spawn", TrySpawnAsMerc, 0);