//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function HaleAttackedMercEvent(params)
{
    local hale = params.attacker;
    local victim = params.const_entity;

    if (IsNotHale(hale) || params.damage_type == 1 || IsHale(victim))
        return;

    haleSaxtonPunchAbility.Perform(hale, victim);

    CreateAoE(victim.GetCenter(), haleAttackAoERadius,
        function (target, deltaVector, distance) {
            if (target == victim)
                return;
            target.TakeDamageEx(
                hale,
                hale,
                hale.GetActiveWeapon(),
                deltaVector,
                hale.GetOrigin(),
                params.damage / 2,
                1);
        }
        function (target, deltaVector, distance) { });
}
AddListener("damage_hook", HaleAttackedMercEvent, -1);

function MercDiedEvent(params)
{
    if (IsNotValidRound() || IsRoundSetup())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    GrantAbilityToPlayer(player, null)

    if (IsRoundOver())
        return;

    local mercsAlive = GetAliveMercCount();
    if (mercsAlive == 1)
        PlaySoundForAll("VSH.Lastman");
    else if (RandomInt(1, 10) == 1)
        PlaySoundForAll("VSH.Killstreak.General");
}
AddListener("death", MercDiedEvent, 0);

function MercSpawnedMidRoundEvent(player)
{
    if (IsNotValidRound() || IsRoundSetup() || IsRoundOver())
        return;
    player.TakeDamage(9999, 0, null);
    NetProps.SetPropInt(player, "m_lifeState", LIFE_STATE.DEAD);
    if (player.GetTeam() != TF_TEAM.MERCS)
        player.ForceChangeTeam(TF_TEAM.MERCS, true);

    local ammoPack = null;
    while (ammoPack = Entities.FindByClassname(ammoPack, "tf_ammo_pack"))
        if (ammoPack.GetOwner() == player)
            ammoPack.Destroy();

}
AddListener("spawn", MercSpawnedMidRoundEvent, -10);