//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class Sound
{
    soundPath = null;
    count = null;
    extension = null;

    constructor(baseSoundFolder, soundPath, count, extension = ".wav")
    {
        if (soundPath.slice(soundPath.len()-1) != "_")
            soundPath = soundPath + "_";
        if (extension.slice(0,1) != ".")
            extension = "."+extension;

        if (baseSoundFolder != null)
        {
            if (baseSoundFolder.slice(baseSoundFolder.len()-1) != "/")
                baseSoundFolder = baseSoundFolder + "/";
            this.soundPath = baseSoundFolder + soundPath;
        }
        else
            this.soundPath = soundPath;
        this.count = count;
        this.extension = extension;

        for(local i = 1; i <= count; i += 1)
            PrecacheSound(GetSound(i));
    }

    function GetSound(index)
    {
        if (index <= 0)
            return GetRandomSound();
        return soundPath + index + extension;
    }

    function GetRandomSound()
    {
        return GetSound(RandomInt(1, count));
    }

    function GetAllSounds()
    {
        for(local i = 1; i <= count; i += 1)
            yield GetSound(i);
        return null;
    }
}