//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function PlaySoundForAll(soundScript)
{
    foreach (player in GetAllValidPlayers())
        EmitSoundOnClient(soundScript, player);
}

::clamp <- function (value, min, max)
{
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}

function IsNotValidRound()
{
    return isFeedbackRound || IsInWaitingForPlayers() || IsNotHale(GetHale());
}

function IsValidRound()
{
    return !isFeedbackRound && !IsInWaitingForPlayers() && IsHale(GetHale());
}

function IsRoundSetup()
{
    return isRoundSetup;
}

function IsRoundOver()
{
    return isRoundOver;
}

function IsPlayingOnTF2MapsNet()
{
    return Convars.GetStr("fb2_version") != null;
}

::PrintCurrentStackTrace <- function()
{
    try
    {
        for(local i=0; i<100; i++)
        {
            local trace = getstackinfos(i);
            if (trace == null)
                break;
            foreach(k,v in trace) printl(k + ": " + v)
            printl("----")
        }
        printl("\n")
    }
    catch(e) { }
}

::SetPersistentVar <- function(name, value)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    persistentVars[name] <- value;
}

::GetPersistentVar <- function(name, defValue = null)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    return name in persistentVars ? persistentVars[name] : defValue;
}

::RunWithDelay <- function(func, activator, delay)
{
    EntFireByHandle(vsh_vscript_entity, "RunScriptCode", func, delay, activator, activator);
}